fs = require('fs');
if process.argv[2]
  src = __dirname.substring(0, __dirname.lastIndexOf("/")) + '/' + process.argv[2]
else
  src = __dirname.substring(0, __dirname.lastIndexOf("/")) + '/' + 'game'
  
class Room
  constructor: (name) ->
    @title(name)

  title: (name) ->
    @name = name
    #print out the name

currentRoom = new Room "Nowhere"

#Quote replacing. Russian style.
replaceQuotes = (data) ->
  data = data.replace(/<</g,"«")
  data = data.replace(/>>/g,"»")
  data = data.replace(/"(\w)/g,($0, $1) -> return '«'+$1)
  data = data.replace(/(\w)"/g,($0, $1) -> return '»'+$1)
  data = data.replace(/,,/g,"„")
  data = data.replace(/''/g,"”")
  return data

parseRoom = (data) -> #data is String
  urls = Array()
  titles = Array()
  html_blocks = Array()
  
  #Standardize line endings, tabs and empty lines
  data = data.replace(/\r(\n)?/g,"\n");
  data = data.replace(/\t/g," ");
  data = data.replace(/^[ \t]+$/g,"");
  
  #remove trailing spaces
  data = data.replace(/(\S)\s+$/,($0, $1) -> return $1);
  
  matches = data.match(/^(.+)\n[=-]+\n+/gm);
  if matches.length>1
    console.error("Error: there is more than one room title.\nThe matching titles are:")
    console.error(matches)
    process.exit(1)
  matches = data.match(/^(.+)\n[=-]+\n+/m);
    
  currentRoom.title(matches[1]);
  
parseGame = (err, data) ->
  if err
    throw err
    return data
  parseRoom(data.toString())

fs.readFile(src+'/main', parseGame);
